unit FileDeleteClass;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,
  StdCtrls, ShellAPI, Masks, Menus, IniFiles, ShlObj, ActiveX, helpsrc, TestMsg,
  ExtCtrls, StrUtils,
  pngimage;

type
  TFolderList = record
    ftype: string[1]; // t@C^Cv@D:tH_̈
    fname: Variant; // tEfBNg
    fn: Variant; // tH_
    fpass: Variant; // pX
    fTime: TDateTime; // XV
    fTimec: TDateTime; // 쐬
    fTimea: TDateTime; // ANZX
    fsize: int64; // TCYioCgj
    fCount: Integer; // t@C
    fsign: Integer; // ς݃TC
    fdel: Integer; // 폜
  end;

  TFileList = record
    ftype: string[1]; // t@C^Cv@F:tH_̈
    fname: Variant; // tEfBNg
    fn: Variant; // tH_
    fpass: Variant; // pX
    fTime: TDateTime; // XV
    fTimec: TDateTime; // 쐬
    fTimea: TDateTime; // ANZX
    fsize: int64; // TCYioCgj
    fKeika: TDateTime; // oߎ
    fdel: Integer; // 폜
  end;

  TFileDelete = class
    DateType: Integer; // t(XV:1A쐬:2AANZX:3)
    DelSubFolder: Boolean; // TutH_폜
    ExExt: string; // Ogq t@C
    ExSize: int64; // OTCY
    ExSizeExec: Boolean; // TCY
    ExSizeSign: Integer; // TCYIvViȏ:1Aȉ:2j
    FileCountLimit: Integer; // t@C
    FileListOutput: Boolean; // t@Cꗗ̏o    //2008/12/04 add
    FindSubFolder: Boolean; // TutH_ĎΏ
    LapsedDays: Integer; // oߓ
    logFile: Boolean; // Ot@C̏o
    LogFileCount: Integer; // Ot@C̍s
    LogSize: Integer; // Ot@C̏s
    ReadOnlyDelete: Boolean; // Ǎpt@CAtH_̍폜
    TargetExt: string; // Ώۊgq t@C
    TargetFolder: string; // ĎΏۃtH_  ij
    TargetFolderItem: string; // ĎΏۃtH_@  iPƁj

    FolderDelCnt: Integer; // tH_폜
    FileDelCnt: Integer; // t@C폜
    FolderCnt: Integer; // FolderList̍s
    FileCnt: Integer; // FileList̍s
    FolderReadPointer: Integer; // ʂ̖̃tH_̃CfbNX
    FolderFileCounter: Integer; // tH_̃t@CEtH_̐
    EndMsg: string; // G[bZ[W
    waitTime: Integer;
    TestMessage: string;
    LogFileName: string;

    FolderList: array of TFolderList;
    FileList: array of TFileList;

    Extsl: TStringList;
    ExExtsl: TStringList;

    constructor Create;
    procedure iniFileWrite;
    procedure iniFileRead;
    function fileSearch: Boolean;
    function deleteAnalysis: Boolean;
    function delete: Boolean;
    function listDeleteFiles: string;
    procedure LogPrintFile(Msg: Ansistring);
    procedure LogPrintStr(str: string);
    procedure LogDelete;

  end;

function FileTimeToDateTime(FileTime: TFileTime): TDateTime;

implementation

// ******************************************************************************
// constructor
// ******************************************************************************
constructor TFileDelete.Create;
begin
  inherited;
  LogFileName := ExtractFilePath(ParamStr(0)) + 'fdel.log';
  TestMessage := '';
end;

procedure TFileDelete.iniFileRead;
// ==========================================================================//
// ini file ǂݍ
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    FindSubFolder := Ini.ReadBool('Folder', 'FindSubFolder', true);
    DelSubFolder := Ini.ReadBool('Folder', 'DelSubFolder', true);
    FileCountLimit := Ini.ReadInteger('Folder', 'FileCountLimit', 100);
    LapsedDays := Ini.ReadInteger('Folder', 'LapsedDays', 3);
    LogSize := Ini.ReadInteger('Folder', 'LogSize', 500);
    logFile := Ini.ReadBool('Folder', 'LogFile', false);
    TargetFolder := Ini.ReadString('Folder', 'TargetFolder', 'c:\test');
    TargetExt := Ini.ReadString('Folder', 'TargetExt', '');
    DateType := Ini.ReadInteger('Folder', 'DateType', 1);
    FileListOutput := Ini.ReadBool('Folder', 'FileListOutput', false);
    ReadOnlyDelete := Ini.ReadBool('Folder', 'ReadOnlyDelete', true);
    ExExt := Ini.ReadString('Folder', 'ExExt', '');
    ExSizeExec := Ini.ReadBool('Folder', 'ExSizeExec', false);
    ExSize := Ini.ReadInteger('Folder', 'ExSize', 10);
    ExSizeSign := Ini.ReadInteger('Folder', 'ExSizeSign', 1);

  finally
    Ini.Free
  end;
end;

procedure TFileDelete.iniFileWrite;
// ==========================================================================//
// ini file 
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    Ini.WriteBool('Folder', 'FindSubFolder', FindSubFolder);
    Ini.WriteBool('Folder', 'DelSubFolder', DelSubFolder);
    Ini.WriteInteger('Folder', 'FileCountLimit', FileCountLimit);
    Ini.WriteInteger('Folder', 'LapsedDays', LapsedDays);
    Ini.WriteInteger('Folder', 'LogSize', LogSize);
    Ini.WriteBool('Folder', 'LogFile', logFile);
    Ini.WriteString('Folder', 'TargetFolder', TargetFolder);
    Ini.WriteString('Folder', 'TargetExt', TargetExt);
    Ini.WriteInteger('Folder', 'DateType', DateType);
    Ini.WriteBool('Folder', 'FileListOutput', FileListOutput);
    Ini.WriteBool('Folder', 'ReadOnlyDelete', ReadOnlyDelete);
    Ini.WriteString('Folder', 'ExExt', ExExt);
    Ini.WriteBool('Folder', 'ExSizeExec', ExSizeExec);
    Ini.WriteInteger('Folder', 'ExSize', ExSize);
    Ini.WriteInteger('Folder', 'ExSizeSign', ExSizeSign);
  finally
    Ini.Free
  end;
end;


// ******************************************************************************
// fileSearch
// ******************************************************************************
function TFileDelete.fileSearch: Boolean;
var
  FolderIndex: Integer;
  FileIndex: Integer;
  SearchRec: TSearchRec;
  p2: string;

begin

  SetLength(FolderList, 10000);
  SetLength(FileList, 10000);

  FolderIndex := 0; // FolderList Write Pointer
  FileIndex := 0; // File Write Pointer
  FolderReadPointer := 0; // FileList Read Pointer
  FolderDelCnt := 0; // tH_폜\萔
  FileDelCnt := 0; // t@C폜\萔
  EndMsg := ''; // GhbZ[W̏
  waitTime := 5; // t@C擾̃EGCgԁ@1/1000P

  if not DirectoryExists(TargetFolderItem) then
  begin
    EndMsg := TargetFolderItem + ' Ώۂ̃tH_L܂';
    result := false;
    exit;
  end;

  Extsl := TStringList.Create;
  Extsl.Delimiter := ',';
  Extsl.DelimitedText := TargetExt;

  ExExtsl := TStringList.Create;
  ExExtsl.Delimiter := ',';
  ExExtsl.DelimitedText := ExExt;

  // ĎtH_̃fBNgAt@C̓ǂݍ
  p2 := TargetFolderItem;

  if copy(p2, length(p2), 1) <> '\' then
    p2 := p2 + '\';
  if 0 = FindFirst(p2 + '*.*', faAnyFile, SearchRec) then
    try
      repeat
        if SearchRec.Attr and faDirectory <> 0 then
        begin
          if (SearchRec.Name = '.') or (SearchRec.Name = '..') then
            Continue;
          FolderList[FolderIndex].ftype := 'D';
          FolderList[FolderIndex].fname := p2 + SearchRec.Name;
          FolderList[FolderIndex].fn := SearchRec.Name;
          FolderList[FolderIndex].fpass := p2;
          FolderList[FolderIndex].fsize := SearchRec.size;
          FolderList[FolderIndex].fTime := FileDateToDateTime(SearchRec.Time);
          FolderList[FolderIndex].fTimec :=
            FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
          FolderList[FolderIndex].fTimea :=
            FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
          FolderList[FolderIndex].fsign := 0;
          FolderList[FolderIndex].fdel := 0;

          FolderIndex := FolderIndex + 1;

          if FolderIndex mod 10000 = 0 then
            SetLength(FolderList, (FolderIndex div 10000 + 1) * 10000);

          Application.ProcessMessages;

          sleep(waitTime);

          if (FileCountLimit <> 0) and (FolderIndex > FileCountLimit) then
          begin
            EndMsg := 'tH_t@ClI[o[';
            Break;
          end;

        end

        else
        begin

          FileList[FileIndex].ftype := 'F';
          FileList[FileIndex].fname := p2 + SearchRec.Name;
          FileList[FileIndex].fn := SearchRec.Name;
          FileList[FileIndex].fpass := p2;
          FileList[FileIndex].fsize := SearchRec.size;
          FileList[FileIndex].fTime := FileDateToDateTime(SearchRec.Time);
          FileList[FileIndex].fTimec :=
            FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
          FileList[FileIndex].fTimea :=
            FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
          if DateType = 1 then
            FileList[FileIndex].fKeika := Now - FileList[FileIndex].fTime;
          if DateType = 2 then
            FileList[FileIndex].fKeika := Now - FileList[FileIndex].fTimec;
          if DateType = 3 then
            FileList[FileIndex].fKeika := Now - FileList[FileIndex].fTimea;
          FileList[FileIndex].fdel := 0;

          FileIndex := FileIndex + 1;

          if FileIndex mod 10000 = 0 then
            SetLength(FileList, (FileIndex div 10000 + 1) * 10000);

          Application.ProcessMessages;

          sleep(waitTime);

          if (FileCountLimit <> 0) and (FileIndex > FileCountLimit) then
          begin
            EndMsg := 't@Ct@ClI[o[';
            Break;
          end;

        end;
      until 0 <> FindNext(SearchRec);
    finally
      FindClose(SearchRec);
    end;

  // TutH_z̃tH_Et@C̓ǂݍ
  if FindSubFolder = true then
  begin
    repeat
      FolderFileCounter := 0;
      begin
        if (FolderList[FolderReadPointer].fsign = 0) and
          (FolderList[FolderReadPointer].ftype = 'D') then
        begin
          FolderList[FolderReadPointer].fsign := 1;
          p2 := FolderList[FolderReadPointer].fname;

          if copy(p2, length(p2), 1) <> '\' then
            p2 := p2 + '\';
          if 0 = FindFirst(p2 + '*.*', faAnyFile, SearchRec) then
            try
              repeat
                if SearchRec.Attr and faDirectory <> 0 then
                begin
                  if (SearchRec.Name = '.') or (SearchRec.Name = '..') then
                    Continue;
                  FolderList[FolderIndex].ftype := 'D';
                  FolderList[FolderIndex].fname := p2 + SearchRec.Name;
                  FolderList[FolderIndex].fn := SearchRec.Name;
                  FolderList[FolderIndex].fpass := p2;
                  FolderList[FolderIndex].fsize := SearchRec.size;
                  FolderList[FolderIndex].fTime :=
                    FileDateToDateTime(SearchRec.Time);
                  FolderList[FolderIndex].fTimec :=
                    FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
                  FolderList[FolderIndex].fTimea :=
                    FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
                  FolderList[FolderIndex].fsign := 0;
                  FolderList[FolderIndex].fdel := 0;

                  FolderIndex := FolderIndex + 1;

                  if FolderIndex mod 10000 = 0 then
                    SetLength(FolderList, (FolderIndex div 10000 + 1) * 10000);

                  Application.ProcessMessages;

                  sleep(waitTime);

                  if (FileCountLimit <> 0) and (FolderIndex > FileCountLimit)
                  then
                  begin
                    EndMsg := 'tH_t@ClI[o[';
                    Break;
                  end;

                  FolderFileCounter := FolderFileCounter + 1;

                end
                else
                begin

                  FileList[FileIndex].ftype := 'F';
                  FileList[FileIndex].fname := p2 + SearchRec.Name;
                  FileList[FileIndex].fn := SearchRec.Name;
                  FileList[FileIndex].fpass := p2;
                  FileList[FileIndex].fsize := SearchRec.size;
                  FileList[FileIndex].fTime :=
                    FileDateToDateTime(SearchRec.Time);
                  FileList[FileIndex].fTimec :=
                    FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
                  FileList[FileIndex].fTimea :=
                    FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
                  if DateType = 1 then
                    FileList[FileIndex].fKeika :=
                      Now - FileList[FileIndex].fTime;
                  if DateType = 2 then
                    FileList[FileIndex].fKeika :=
                      Now - FileList[FileIndex].fTimec;
                  if DateType = 3 then
                    FileList[FileIndex].fKeika :=
                      Now - FileList[FileIndex].fTimea;
                  FileList[FileIndex].fdel := 0;

                  FileIndex := FileIndex + 1;
                  if FileIndex mod 10000 = 0 then
                    SetLength(FileList, (FileIndex div 10000 + 1) * 10000);
                  Application.ProcessMessages;
                  sleep(waitTime);

                  if (FileCountLimit <> 0) and (FileIndex > FileCountLimit) then
                  begin
                    EndMsg := 't@Ct@ClI[o[';
                    Break;
                  end;

                  FolderFileCounter := FolderFileCounter + 1;

                end;
              until 0 <> FindNext(SearchRec);
            finally
              FindClose(SearchRec);
            end;
          FolderList[FolderReadPointer].fCount := FolderFileCounter;
          if FolderReadPointer >= FolderIndex then
            Break;
        end;
      end;
      FolderReadPointer := FolderReadPointer + 1;
    until (FolderReadPointer >= FolderIndex);
  end;
  FileCnt := FileIndex;
  FolderCnt := FolderIndex;
  result := true;
end;

// ******************************************************************************
// deleteAnalysis
// ******************************************************************************
function TFileDelete.deleteAnalysis: Boolean;
var
  FolderIndex: Integer;
  FileIndex: Integer;
  ExtI: Integer;
  ExExtI: Integer;

begin
  // t@Cꗗ̔
  for FileIndex := 0 to FileCnt - 1 do
  begin

    // oߓ
    if (trunc(FileList[FileIndex].fKeika) + 1 > LapsedDays) then
    begin

      // [hI[
      if not((ReadOnlyDelete = false) and
        ((FileGetAttr(FileList[FileIndex].fname) and faReadOnly) <> 0)) then

      begin
        // t@CTCY
        if (ExSizeExec = false) or ((ExSizeExec = true) and (ExSizeSign = 1) and
          (FileList[FileIndex].fsize < ExSize * 1000000)) or
          ((ExSizeExec = true) and (ExSizeSign = 2) and
          (FileList[FileIndex].fsize > ExSize * 1000000)) then
        begin

          // t@CAgqFwȂ
          if (Extsl.Count = 0) and (ExExtsl.Count = 0) then
          begin
            FileList[FileIndex].fdel := 1;
            FileDelCnt := FileDelCnt + 1;
          end;

          // Ώۃt@CAgq
          if (Extsl.Count <> 0) and (ExExtsl.Count = 0) then
          begin
            for ExtI := 0 to Extsl.Count - 1 do
            begin
              if AnsiPos('.', Extsl.Strings[ExtI]) = 0 then
              begin
                Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];
              end;
              if MatchesMask(FileList[FileIndex].fn, Extsl.Strings[ExtI]) then
              begin
                FileList[FileIndex].fdel := 1;
                FileDelCnt := FileDelCnt + 1;
              end;
            end;
          end;

          // Ot@CAgq
          if (Extsl.Count = 0) and (ExExtsl.Count <> 0) then
          begin
            FileList[FileIndex].fdel := 1;
            FileDelCnt := FileDelCnt + 1;
            for ExExtI := 0 to ExExtsl.Count - 1 do
            begin
              if AnsiPos('.', ExExtsl.Strings[ExExtI]) = 0 then
              begin
                ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI];
              end;
              if MatchesMask(FileList[FileIndex].fn, ExExtsl.Strings[ExExtI])
              then
              begin
                FileList[FileIndex].fdel := 0;
                FileDelCnt := FileDelCnt - 1;
              end;
            end;
          end;

          // t@CAgq
          if (Extsl.Count <> 0) and (ExExtsl.Count <> 0) then
          begin
            for ExtI := 0 to Extsl.Count - 1 do
            begin
              if AnsiPos('.', Extsl.Strings[ExtI]) = 0 then
              begin
                Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];
              end;
              if MatchesMask(FileList[FileIndex].fn, Extsl.Strings[ExtI]) then
              begin
                FileList[FileIndex].fdel := 1;
                FileDelCnt := FileDelCnt + 1;
                for ExExtI := 0 to ExExtsl.Count - 1 do
                begin
                  if AnsiPos('.', ExExtsl.Strings[ExExtI]) = 0 then
                  begin
                    ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI];
                  end;
                  if MatchesMask(FileList[FileIndex].fn, ExExtsl.Strings[ExExtI])
                  then
                  begin
                    FileList[FileIndex].fdel := 0;
                    FileDelCnt := FileDelCnt - 1;
                  end;
                end;
              end;
            end;
          end;
          // 
        end;
      end;
    end;
  end;

  // tH_[ꗗ̔
  for FolderIndex := 0 to FolderCnt - 1 do
  begin
    if (FolderList[FolderIndex].fCount = 0) and (DelSubFolder = true) then
    begin
      FolderList[FolderIndex].fdel := 1;
      FolderDelCnt := FolderDelCnt + 1;
    end
    else
      FolderList[FolderIndex].fdel := 0;
  end;

  result := true;

end;

// ******************************************************************************
// listDeleteFiles
// ******************************************************************************
function TFileDelete.listDeleteFiles: string;
var
  FolderIndex: Integer;
  FileIndex: Integer;
  bn: string;
  bdate: string;
  bdatec: string;
  bdatea: string;
  bKeika: string;
  bsize: int64;
  bReadOnly: string;
  SearchRec: TSearchRec;

begin

  LogPrintStr('');
  LogPrintStr('ΏۃtH_F' + TargetFolderItem);
  LogPrintStr('');
  if EndMsg <> '' then
    LogPrintStr(EndMsg)
  else
  begin
    if FileListOutput then
    begin

      LogPrintStr('[t@Cꗗ]');
      LogPrintStr('' + #9 + 'XV@@         ' + #9 + '쐬   @@      ' + #9 +
        'ANZX       ' + #9 + '' + #9 + 'byte' + #9'RO' + #9 + 't@C@');

      for FolderIndex := 0 to FolderCnt - 1 do
      begin
        bn := FolderList[FolderIndex].fname;
        bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FolderList[FolderIndex].fTime);
        bdatec := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FolderList[FolderIndex].fTimec);
        bdatea := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FolderList[FolderIndex].fTimea);
        bsize := FolderList[FolderIndex].fsize;

        if FileGetAttr(FolderList[FolderIndex].fname) and faReadOnly <> 0 then
          bReadOnly := 'Yes'
        else
          bReadOnly := '---';

        LogPrintStr('D' + #9 + bdate + #9 + bdatec + #9 + bdatea + #9#9 +
          IntToStr(bsize) + #9 + bReadOnly + #9 + bn);
      end;

      for FileIndex := 0 to FileCnt - 1 do
      begin
        bn := FileList[FileIndex].fname;
        bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FileList[FileIndex].fTime);
        bdatec := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FileList[FileIndex].fTimec);
        bdatea := FormatDateTime('yyyy/mm/dd hh:nn:ss',
          FileList[FileIndex].fTimea);
        bKeika := IntToStr(trunc(FileList[FileIndex].fKeika));
        bsize := FileList[FileIndex].fsize;

        if FileGetAttr(FileList[FileIndex].fname) and faReadOnly <> 0 then //
          bReadOnly := 'Yes'
        else
          bReadOnly := '---';

        // eXgbZ[Wo
        LogPrintStr('F' + #9 + bdate + #9 + bdatec + #9 + bdatea + #9 + bKeika +
          #9 + IntToStr(bsize) + #9 + bReadOnly + #9 + bn);

      end;

    end;

    LogPrintStr('');

    LogPrintStr('tH_: ' + IntToStr(FolderCnt) + ' 폜Ώې: ' +
      IntToStr(FolderDelCnt));

    // 폜ΏۃtH_̕\
    for FolderIndex := 0 to FolderCnt - 1 do
    begin
      if FolderList[FolderIndex].fdel = 1 then
        LogPrintStr(FolderList[FolderIndex].fname);
      Application.ProcessMessages;
      sleep(waitTime);
    end;

    LogPrintStr('');

    LogPrintStr('t@C: ' + IntToStr(FileCnt) + ' 폜Ώې: ' +
      IntToStr(FileDelCnt));

    // 폜Ώۃt@C̕\
    for FileIndex := 0 to FileCnt - 1 do
    begin
      if FileList[FileIndex].fdel = 1 then
        LogPrintStr(FileList[FileIndex].fname);
      Application.ProcessMessages;
      sleep(waitTime);
    end;
  end;
  result := TestMessage;

end;

// ******************************************************************************
// delete
// ******************************************************************************
function TFileDelete.delete: Boolean;
var
  FolderIndex: Integer;
  FileIndex: Integer;
  rc: Boolean;
begin

  LogPrintFile('<' + TargetFolderItem + ' : tH_ : ' + IntToStr(FolderCnt) +
    ' ,폜Ώ : ' + IntToStr(FolderDelCnt) + ' ,t@C : ' + IntToStr(FileCnt) +
    ' ,폜Ώ : ' + IntToStr(FileDelCnt) + '>');

  // tH_폜
  for FolderIndex := 0 to FolderCnt - 1 do
  begin
    if FolderList[FolderIndex].fdel = 1 then
    begin

      IF (FileGetAttr(FolderList[FolderIndex].fname) and faReadOnly) > 0 Then
      begin
        FileSetAttr(FolderList[FolderIndex].fname,
          FileGetAttr(FolderList[FolderIndex].fname) - faReadOnly);
      end;

      rc := RemoveDir(FolderList[FolderIndex].fname);

      if rc = true then
        LogPrintFile(FolderList[FolderIndex].fname + #9 + '-> Delete Success')
      else
        LogPrintFile(FolderList[FolderIndex].fname + #9 + '-> Delete Failure... ');
      Application.ProcessMessages;
      sleep(waitTime);

    end;
  end;

  // t@C폜
  for FileIndex := 0 to FileCnt - 1 do
  begin
    if FileList[FileIndex].fdel = 1 then
    begin

      IF (FileGetAttr(FileList[FileIndex].fname) and faReadOnly) > 0 Then
      begin
        FileSetAttr(FileList[FileIndex].fname,
          FileGetAttr(FileList[FileIndex].fname) - faReadOnly);
      end;

      rc := DeleteFile(FileList[FileIndex].fname);

      if rc = true then
        LogPrintFile(FileList[FileIndex].fname + #9 + '-> Delete Success')
      else
        LogPrintFile(FileList[FileIndex].fname + #9 + '-> Delete Failure...');
      Application.ProcessMessages;
      sleep(waitTime);

    end;
  end;

  result := true;

end;

// ******************************************************************************
// FileTimeToDateTime
// ******************************************************************************
function FileTimeToDateTime(FileTime: TFileTime): TDateTime;
var
  LocalFileTime: TFileTime;
  SystemTime: TSystemTime;
begin
  result := 0;
  if (FileTime.dwLowDateTime = 0) and (FileTime.dwHighDateTime = 0) then
    exit;
  FileTimeToLocalFileTime(FileTime, LocalFileTime);
  FileTimeToSystemTime(LocalFileTime, SystemTime);
  result := SystemTimeToDateTime(SystemTime);
end;

// ******************************************************************************
// LogPrintFile
// ******************************************************************************
procedure TFileDelete.LogPrintFile(Msg: Ansistring);
var
  fs: TFileStream;
begin
  if logFile = false then
  begin
    Msg := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now) + #9 + Msg + #13#10;
    if FileExists(LogFileName) then
      fs := TFileStream.Create(LogFileName, fmOpenReadWrite)
    else
      fs := TFileStream.Create(LogFileName, fmCreate);
    LogFileCount := LogFileCount + 1;
    fs.Position := fs.size;
    fs.WriteBuffer(PChar(Msg)^, length(Msg));
    fs.Free;
    if LogSize <> 0 then
    begin
      if LogFileCount > LogSize then
        LogDelete;
    end;
  end;
end;

// ******************************************************************************
// LogDelete
// ******************************************************************************
procedure TFileDelete.LogDelete;
var
  sl: TStringList;
  i: Integer;
  max: Integer;
begin
  sl := TStringList.Create;
  sl.LoadFromFile(LogFileName);
  max := LogFileCount - LogSize + trunc(LogSize * 0.1);
  for i := 0 to max do
  begin
    sl.delete(0);
  end;
  sl.SaveToFile(LogFileName);
  LogFileCount := sl.Count;
  sl.Free;
end;

// ******************************************************************************
// LogPrintStr
// ******************************************************************************
procedure TFileDelete.LogPrintStr(str: string);
Begin
  TestMessage := TestMessage + FormatDateTime('yyyy/mm/dd hh:nn:ss', Now) + #9 +
    str + #13#10;
end;

end.
