﻿// ==========================================================================//
// fdel (file delete)                          create t.ohishi 2009/03/23
// --------------------------------------------------------------------------//
// 20090323 : 監視間隔、経過日数のアップダウン時にカンマを挿入していた為、
// （V2.1）　 1000以上の数値が入ると型変換エラーが発生していた。
// カンマを挿入しないように修正した。
//
// 削除実行は設定後、監視間隔で設定した時間を経過後に実行される。
// テスト実行後に、直ちに削除したい時は、この経過時間を待つのは
// もどかしいため即時削除機能を追加した。
//
// ログの見栄えを修正した。
//
// 20090326 : 複数フォルダを対象に削除処理が可能にした。
// （V2.2）
// 起動パスが異なれば、複数のfdelを立ち上げ可能にした。
// 20090329 : ログ書き出し上限の追加
// （V2.3）　 ファイル数制限の解除できるように変更
// 20090402 : 読取専用属性のファイル、フォルダの削除を追加
// （V2.4）
// 20090422 : バッチ処理モードの追加
// （V2.5）
// 20090812 : 読取専用属性のファイル、フォルダの削除オプションを追加
// （V2.6）
// 20090826 : 除外条件（拡張子、ファイルサイズ）の追加
// （V2.7）
// 20090927 : ２ＧＢ以上のファイルを認識出来ないバグを修正
// （V2.71）
// 20090927 : ファイル数が10,000まで処理できないバグを修正
// （V2.72）
// 20091118 : 経過日数に0日を指定可能に変更
// （V2.8）
// 20090122 : バッチ処理モードのバグ修正（タスクトレー登録処理バイパス）
// （V2.81）
// 20110517 : 削除対象フォルダを複数していた際に、一部のフォルダの指定が消えてしまうバグ修正
// （V2.82）
// 20130108 : 対象拡張子及び除外拡張子を、対象ファイル名及び除外ファイル名に変更
// （V2.9）
// 20130206 : メインの削除処理をクラスに分離　スタートアップ登録を追加
// (v3.0)
//
// ==========================================================================//
unit fdelsrc;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,
  StdCtrls, ShellAPI, Masks, Menus, IniFiles, ShlObj, ActiveX, helpsrc, TestMsg,
  ExtCtrls, StrUtils,
  pngimage, FileDeleteClass, startup;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Memo1: TMemo;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    PopupMenu1: TPopupMenu;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Timer2: TTimer;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    UpDown5: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button7Click(Sender: TObject);

  private
    FD: TFileDelete;
    procedure CreateTaskBarIcon;
    procedure DeleteTaskBarIcon;
    procedure iniFileRead;
    procedure iniFileWrite;
    procedure OKPro;
    procedure SetuteiToVar;
    procedure TaskTrayWndProc(var Msg: TMessage);
    procedure Timer2Pro;
    procedure UpdateSignSet;
    procedure UpdateTaskBarIcon;
    procedure VarToSetutei;
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession);
      message WM_QUERYENDSESSION;

  public

  end;

function BrowseCallbackProc(hWnd: hWnd; uMsg: UINT; lParam, lpData: lParam)
  : Integer stdCall;
function FileTimeToDateTime(FileTime: TFileTime): TDateTime;

var
  // ==========================================================================//
  // 変数宣言
  // ==========================================================================//
  Form1: TForm1; //
  hWndTrayIcon: Longint; //
  uTaskBarRecreate: Longint; //
  BI: TBrowseInfo; //
  FQueryEndSession: Boolean; //
  Msg: string; //
  NextRunTime: TDateTime; //
  Interval: Integer; // 監視間隔
  stop: Boolean; // 監視一時停止
  stopBefore: Boolean; //
  stopTime: TDateTime; //
  UpdateInfo: Boolean; // 設定変更サイン
  UpdateSign: Boolean; // 設定変更監視中サイン

implementation

// ==========================================================================//
// プライベート宣言
// ==========================================================================//

{$R *.dfm}

const
  // ==========================================================================//
  // 定数宣言
  // ==========================================================================//
  WM_MY_TRAYICON = WM_USER + 100;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
// ==========================================================================//
// フォームクローズイベント
// 終了した時にトレイのアイコンを削除
// ==========================================================================//
begin
  if FQueryEndSession then
  begin
    FQueryEndSession := false;
    DeleteTaskBarIcon;
    DeallocateHWnd(hWndTrayIcon);
    FD.LogPrintFile('<Windows shutdown>');
    close;
  end
  else
  begin
    iniFileWrite;
    DeleteTaskBarIcon;
    DeallocateHWnd(hWndTrayIcon);
    FD.LogPrintFile('<fdel end>');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
// ==========================================================================//
// フォーム作成イベント
// 起動直後はトレイにアイコン表示する
// ==========================================================================//
var
  sl: TStringList;
begin
  FD := TFileDelete.create;

  if ParamStr(1) <> '/b' then
  begin
    uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
    hWndTrayIcon := AllocateHWnd(TaskTrayWndProc);
    CreateTaskBarIcon;
  end;

  ShowWindow(Application.Handle, SW_HIDE);
  Application.ShowMainForm := false;
  UpdateSign := false;
  UpdateInfo := false;

  // initファイル読込
  iniFileRead;

  // logfileの行数確認
  if FileExists(FD.LogFileName) then
  begin
    sl := TStringList.create;
    sl.LoadFromFile(FD.LogFileName);
    FD.LogFileCount := sl.Count;
    sl.Free;
  end
  else
    FD.LogFileCount := 0;

  // オプションのチェック
  if ParamCount <> 0 then
  begin
    if ParamCount = 1 then
    begin
      if ParamStr(1) = '/b' then
      begin
        Timer2Pro;
        Application.Terminate;
        exit;
      end
      else
      begin
        FD.LogPrintFile('<Option Error> : ' + ParamStr(1));
        Application.Terminate;
        exit;
      end;
    end
    else
    begin
      FD.LogPrintFile('<Option Error> : Option Count Over');
      Application.Terminate;
      exit;
    end;

  end;

  // 起動メッセージ出力
  FD.LogPrintFile('<fdel start>');

  // サブフォルダ　チェックボックスの表示制御
  if CheckBox2.Checked = true then
    CheckBox3.Enabled := true
  else
  begin
    CheckBox3.Enabled := false;
    CheckBox3.Checked := false;
  end;

  // タイマー１セット
  Timer1.Interval := 1000; // 1秒タイマーセット
  Timer1.Enabled := true; // タイマー１スタート

  // タイマー２セット
  Timer2.Interval := Interval * 60 * 1000; // 分を1/1000秒に変換
  Timer2.Enabled := true; // タイマー２スタート

  // 現時刻の表示
  StatusBar1.Panels[1].Text := '現在　' + FormatDateTime('mm/dd hh:nn:ss', Now);

  // 削除処理の実行時刻を表示
  StatusBar1.Panels[0].Text := '次回　' + FormatDateTime('mm/dd hh:nn:ss',
    Now + (1 / 1440 * Interval));

  // 次回削除時間の保管
  NextRunTime := Now + (1 / 1440 * Interval);

  // STOPTIMEの保管
  stopBefore := stop; // stop状態の保管
  if stop = true then
    stopTime := Now;

end;

procedure TForm1.WMQueryEndSession(var Msg: TWMQueryEndSession);
// ==========================================================================//
// シャットダウンイベント
// ==========================================================================//
begin
  FQueryEndSession := true;
  inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
// ==========================================================================//
// 参照ボタンクリックイベント
// 監視対象フォルダを指定する
// ==========================================================================//
var
  Memory: IMalloc;
  Buffer: PChar;
  Ret, Root: PItemIDList;

begin
  SHGetMalloc(Memory);
  Buffer := Memory.Alloc(MAX_PATH);

  // 「デスクトップ」フォルダの位置を取得する
  SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, Root);

  // BrowseInfo構造体の初期設定
  BI.hwndOwner := Form1.Handle; // 親ウインドウのハンドル
  BI.pidlRoot := Root; // ルートフォルダ(CSIDL_××)
  BI.ulFlags := BIF_STATUSTEXT; // フォルダのタイプを示すフラグﾞ(BIF_××)
  BI.lpszTitle := 'フォルダの選択'; // タイトル（解説文）
  BI.pszDisplayName := Buffer; // (戻り値)フォルダ名
  BI.lpfn := BrowseCallbackProc; // コールバック関数のエントリポイント

  // 「フォルダの参照」ダイアログを表示
  Ret := SHBrowseForFolder(BI);

  // ITEMIDLIST構造体からパス名を取り出す
  if SHGetPathFromIDList(Ret, Buffer) then
    Memo1.Text := (Buffer);

  // メモリの解放
  Memory.Free(Ret);
  Memory.Free(Root);
  Memory.Free(Buffer);
end;

procedure TForm1.Button6Click(Sender: TObject);
// ==========================================================================//
// 追加ボタンクリックイベント
// 監視対象フォルダを追加指定する
// ==========================================================================//
var
  Memory: IMalloc;
  Buffer: PChar;
  Ret, Root: PItemIDList;
begin
  SHGetMalloc(Memory);
  Buffer := Memory.Alloc(MAX_PATH);

  // 「デスクトップ」フォルダの位置を取得する
  SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, Root);

  // BrowseInfo構造体の初期設定
  BI.hwndOwner := Form1.Handle; // 親ウインドウのハンドル
  BI.pidlRoot := Root; // ルートフォルダ(CSIDL_××)
  BI.ulFlags := BIF_STATUSTEXT; // フォルダのタイプを示すフラグﾞ(BIF_××)
  BI.lpszTitle := 'フォルダの選択'; // タイトル（解説文）
  BI.pszDisplayName := Buffer; // (戻り値)フォルダ名
  BI.lpfn := BrowseCallbackProc; // コールバック関数のエントリポイント

  // 「フォルダの参照」ダイアログを表示
  Ret := SHBrowseForFolder(BI);

  // ITEMIDLIST構造体からパス名を取り出す
  if SHGetPathFromIDList(Ret, Buffer) then
  begin
    if Memo1.Text = '' then
      Memo1.Text := Buffer
    else
      Memo1.Text := Memo1.Text + ';' + Buffer;
  end;

  // メモリの解放
  Memory.Free(Ret);
  Memory.Free(Root);
  Memory.Free(Buffer);

end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  form4.ShowModal;
end;

procedure TForm1.Button2Click(Sender: TObject);
// ==========================================================================//
// テストボタンクリックイベント
// 削除処理のテスト及び結果表示
// ==========================================================================//
var
  sl: TStringList;
  i: Integer;

begin
  SetuteiToVar;

  // 設定値の出力
  Form3.Memo1.Text := '';
  FD.LogPrintStr('<テスト開始>');
  FD.LogPrintStr('[設定値]');
  FD.LogPrintStr('監視対象フォルダ' + #9 + ': ' + FD.TargetFolder);
  FD.LogPrintStr('ファイル名' + #9 + ': ' + FD.TargetExt);
  FD.LogPrintStr('監視間隔　　' + #9 + ': ' + IntToStr(Interval) + '分');
  FD.LogPrintStr('経過日数　　' + #9 + ': ' + IntToStr(FD.LapsedDays) + '日');
  FD.LogPrintStr('サブフォルダ対象' + #9 + ': ' + ifthen(FD.FindSubFolder,
    'はい', 'いいえ'));
  FD.LogPrintStr('空サブフォルダ削除' + #9 + ': ' + ifthen(FD.DelSubFolder,
    'はい', 'いいえ'));
  FD.LogPrintStr('読取専用削除' + #9 + ': ' + ifthen(FD.ReadOnlyDelete, 'はい', 'いいえ'));
  FD.LogPrintStr('ファイル数制限' + #9 + ': ' + IntToStr(FD.FileCountLimit));
  FD.LogPrintStr('除外ファイル名' + #9 + ': ' + FD.ExExt);
  FD.LogPrintStr('サイズ制限' + #9 + ': ' + ifthen(FD.ExSizeExec, 'はい', 'いいえ'));
  FD.LogPrintStr('除外サイズ(MB)' + #9 + ': ' + IntToStr(FD.ExSize));
  FD.LogPrintStr('除外サイズオプション' + #9 + ': ' + ifthen(FD.ExSizeSign = 1, '以上',
    ifthen(FD.ExSizeSign = 2, '以下', '指定なし')));
  FD.LogPrintStr('経過日数計算基準' + #9 + ': ' + ifthen(FD.DateType = 1, '更新日',
    ifthen(FD.DateType = 2, '作成日', 'アクセス日')));
  FD.LogPrintStr('ファイル一覧出力' + #9 + ': ' + ifthen(FD.FileListOutput,
    'はい', 'いいえ'));
  FD.LogPrintStr('ログ書出し無し' + #9 + ': ' + ifthen(FD.logFile, 'はい', 'いいえ'));
  FD.LogPrintStr('ログ書出し上限' + #9 + ': ' + IntToStr(FD.LogSize));

  sl := TStringList.create;
  sl.Delimiter := ';';
  sl.DelimitedText := AnsiReplaceText(Memo1.Text, ' ', '*');

  for i := 0 to sl.Count - 1 do
  begin
    // フォルダ名をターゲットフォルダ変数にセット
    FD.TargetFolderItem := AnsiReplaceText(sl.Strings[i], '*', ' ');
    if FD.TargetFolderItem <> '' then
    begin

      FD.fileSearch;
      FD.deleteAnalysis;
      FD.listDeleteFiles;

    end;
  end;
  Form3.Memo1.Lines.add(FD.TestMessage);
  FD.TestMessage := '';
  sl.Free;

  // 結果出力
  Form3.ShowModal;

end;

procedure TForm1.SetuteiToVar;
// ==========================================================================//
// 設定画面の値を変数に保存する
// ==========================================================================//
begin
  stop := CheckBox1.Checked; // 監視一時停止
  FD.FindSubFolder := CheckBox2.Checked; // サブフォルダ対象
  FD.DelSubFolder := CheckBox3.Checked; // 空フォルダの削除
  FD.FileCountLimit := StrToInt(Edit5.Text); // ファイルリミット
  FD.LapsedDays := StrToInt(Edit3.Text); // 経過日数
  Interval := StrToInt(Edit4.Text); // 監視間隔
  FD.TargetFolder := Memo1.Text; // 対象フォルダ
  FD.TargetExt := Edit2.Text; // 対象拡張子 ◆ファイル名
  FD.logFile := CheckBox5.Checked; // ログ書き出し無し
  FD.LogSize := StrToInt(Edit6.Text); // ログ下記出し行数上限
  FD.ReadOnlyDelete := CheckBox6.Checked; // 読取専用ファイル、フォルダの削除
  FD.ExExt := Edit1.Text; // 除外拡張子 ◆ファイル名
  FD.ExSizeExec := CheckBox7.Checked; // サイズ除外の実行
  FD.ExSize := StrToInt(Edit7.Text); // 除外サイズ

  if RadioButton4.Checked then
    FD.ExSizeSign := 1;
  if RadioButton5.Checked then
    FD.ExSizeSign := 2;

  FD.FileListOutput := CheckBox4.Checked; // ファイル一覧出力

  if RadioButton1.Checked then
    FD.DateType := 1;
  if RadioButton2.Checked then
    FD.DateType := 2;
  if RadioButton3.Checked then
    FD.DateType := 3;

end;

procedure TForm1.VarToSetutei;
// ==========================================================================//
// 変数の値を設定画面に反映する
// ==========================================================================//
begin
  CheckBox1.Checked := stop;
  CheckBox2.Checked := FD.FindSubFolder;
  CheckBox3.Checked := FD.DelSubFolder;
  Edit5.Text := IntToStr(FD.FileCountLimit);
  Edit3.Text := IntToStr(FD.LapsedDays);
  Edit4.Text := IntToStr(Interval);
  Memo1.Text := FD.TargetFolder;
  Edit2.Text := FD.TargetExt;
  CheckBox5.Checked := FD.logFile;
  Edit6.Text := IntToStr(FD.LogSize);
  CheckBox6.Checked := FD.ReadOnlyDelete;
  Edit1.Text := FD.ExExt;
  CheckBox7.Checked := FD.ExSizeExec;
  Edit7.Text := IntToStr(FD.ExSize);

  if FD.ExSizeSign = 1 then
    RadioButton4.Checked := true;
  if FD.ExSizeSign = 2 then
    RadioButton5.Checked := true;

  CheckBox4.Checked := FD.FileListOutput;

  if FD.DateType = 1 then
    RadioButton1.Checked := true;
  if FD.DateType = 2 then
    RadioButton2.Checked := true;
  if FD.DateType = 3 then
    RadioButton3.Checked := true;
  UpdateSign := true;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Button3Click(Sender: TObject);
// ==========================================================================//
// ＯＫボタン
// 設定画面を非表示にして、タイマー処理を開始する
// ==========================================================================//
begin
  // 確認メッセージ
  if UpdateInfo = true then
  begin
    if Application.MessageBox('設定を保存しますか？', '確認', MB_OKCANCEL) = IDCANCEL then
      exit;
    OKPro;
  end;
  UpdateSign := false;
  UpdateInfo := false;
  Form1.Visible := false;
end;

procedure TForm1.OKPro;
// ==========================================================================//
// ＯＫボタン
// 設定画面を非表示にして、タイマー処理を開始する
// ==========================================================================//
begin

  // 監視間隔の設定
  if StrToInt(Edit4.Text) <> Interval then
  begin
    Timer2.Interval := StrToInt(Edit4.Text) * 60 * 1000; // 分を1/1000秒に変換
    Timer2.Enabled := true;
    StatusBar1.Panels[1].Text := '現在　' + FormatDateTime('mm/dd hh:nn:ss', Now);
    StatusBar1.Panels[0].Text := '次回　' + FormatDateTime('mm/dd hh:nn:ss',
      Now + (1 / 1440 * StrToInt(Edit4.Text)));
    NextRunTime := Now + (1 / 1440 * StrToInt(Edit4.Text));
  end;

  // 対象フォルダの整形
  Memo1.Text := Trim(Memo1.Text); // 前後の空白を取り除く
  Memo1.Text := AnsiReplaceText(Memo1.Text, ',', ';'); // カンマをセミコロンに変換する
  Memo1.Text := AnsiReplaceText(Memo1.Text, ';;', ';');
  // セミコロン２文字をセミコロン１文字に変換する
  Memo1.Text := AnsiReplaceText(Memo1.Text, ';;', ';');
  // セミコロン２文字をセミコロン１文字に変換する
  Memo1.Text := AnsiReplaceText(Memo1.Text, ';;', ';');
  // セミコロン２文字をセミコロン１文字に変換する
  if RightStr(Memo1.Text, 1) = ';' then // 最後の;セミコロンを削除する
    Memo1.Text := LeftStr(Memo1.Text, length(Memo1.Text) - 1);

  SetuteiToVar; // 設定を変数に格納する
  iniFileWrite; // iniファイルに設定を書き出す

  {
    FD.LogPrintStr('');
    FD.LogPrintStr('□設定が保存されました。');
    FD.LogPrintStr('監視停止　　' + #9 + ': ' + ifthen(stop, '停止', '稼働'));
    FD.LogPrintStr('監視対象フォルダ ' + #9 + ': ' + FD.TargetFolder);
    FD.LogPrintStr('ファイル名' + #9 + ': ' + FD.TargetExt);
    FD.LogPrintStr('監視間隔　　' + #9 + ': ' + IntToStr(Interval) + '分');
    FD.LogPrintStr('経過日数　　' + #9 + ': ' + IntToStr(FD.LapsedDays) + '日');
    FD.LogPrintStr('サブフォルダ対象' + #9 + ': ' + ifthen(FD.FindSubFolder, 'はい', 'いいえ'));
    FD.LogPrintStr('空サブフォルダ削除' + #9 + ': ' + ifthen(FD.DelSubFolder, 'はい', 'いいえ'));
    FD.LogPrintStr('読取専用削除' + #9 + ': ' + ifthen(FD.ReadOnlyDelete, 'はい', 'いいえ'));
    FD.LogPrintStr('ファイル数制限' + #9 + ': ' + IntToStr(FD.FileCountLimit));
    FD.LogPrintStr('除外ファイル名' + #9 + ': ' + FD.ExExt);
    FD.LogPrintStr('サイズ制限' + #9 + ': ' + ifthen(FD.ExSizeExec, 'はい', 'いいえ'));
    FD.LogPrintStr('除外サイズ(MB)' + #9 + ': ' + IntToStr(FD.ExSize));
    FD.LogPrintStr('除外サイズオプション' + #9 + ': ' + ifthen(FD.ExSizeSign = 1, '以上',
    ifthen(FD.ExSizeSign = 2, '以下', '指定なし')));
    FD.LogPrintStr('経過日数計算基準' + #9 + ': ' + ifthen(FD.DateType = 1, '更新日',
    ifthen(FD.DateType = 2, '作成日', 'アクセス日')));
    FD.LogPrintStr('ファイル一覧出力' + #9 + ': ' + ifthen(FD.FileListOutput, 'はい', 'いいえ'));
    FD.LogPrintStr('ログ書出し無し' + #9 + ': ' + ifthen(FD.logFile, 'はい', 'いいえ'));
    FD.LogPrintStr('ログ書出し上限' + #9 + ': ' + IntToStr(FD.LogSize));
    FD.LogPrintStr('');
  }
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Button4Click(Sender: TObject);
// ==========================================================================//
// キャンセルボタンクリックイベント
// 設定値を廃棄して設定画面をクローズする
// ==========================================================================//
begin
  iniFileRead;
  Form1.Visible := false;
  UpdateSign := false;
  UpdateInfo := false;
  VarToSetutei;
end;

procedure TForm1.Button5Click(Sender: TObject);
// ==========================================================================//
// 即時削除
// ==========================================================================//
begin
  // 確認メッセージ
  if Application.MessageBox('即時削除しますか？　設定は保存されます。', '確認', MB_OKCANCEL) = IDCANCEL
  then
    exit;
  FD.LogPrintFile('<即時削除が実行されました。>');
  OKPro;
  Timer2Pro;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
// ==========================================================================//
// 監視一時停止ボタンクリックイベント
// ==========================================================================//
begin
  UpdateSignSet;
  if CheckBox1.Checked = true then
  begin
    N2.Checked := true;
    stop := true;
  end
  else
  begin
    N2.Checked := false;
    stop := false;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
// ==========================================================================//
// サブフォルダチェックボックスクリックイベント
// ==========================================================================//
begin
  UpdateSignSet;
  if CheckBox2.Checked = true then
    CheckBox3.Enabled := true
  else
  begin
    CheckBox3.Enabled := false;
    CheckBox3.Checked := false;
  end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CreateTaskBarIcon;
// ==========================================================================//
// アイコンをトレイに登録する
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
  rc: Boolean;
  sl: TStringList;
  i: Integer;
  str: string;

begin
  with NotifyData do
  begin
    // cbSize := SizeOf(TNotifyIconData);
    cbSize := 100;
    Wnd := hWndTrayIcon;
    uID := 0;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;

    sl := TStringList.create;
    sl.Delimiter := '\';
    sl.DelimitedText := ExtractFilePath(Application.ExeName);
    i := sl.Count - 2;
    str := 'fdel ' + sl.Strings[i];
    StrCopy(szTip, PChar(str));
    sl.Free;

    hIcon := Application.Icon.Handle;
    uCallbackMessage := WM_MY_TRAYICON;
  end;
  rc := Shell_NotifyIcon(NIM_ADD, @NotifyData);
  if rc then
  else
  begin
    sleep(5000);
    CreateTaskBarIcon;
  end;
end;

procedure TForm1.UpdateTaskBarIcon;
// ==========================================================================//
// タスクトレイのアイコンを変更する
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
  sl: TStringList;
  i: Integer;
  str: string;

begin
  with NotifyData do
  begin
    // cbSize := SizeOf(TNotifyIconData);
    cbSize := 100;
    Wnd := hWndTrayIcon;
    uID := 0;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;

    sl := TStringList.create;
    sl.Delimiter := '\';
    sl.DelimitedText := ExtractFilePath(Application.ExeName);
    i := sl.Count - 2;
    str := 'fdel ' + sl.Strings[i];
    StrCopy(szTip, PChar(str));
    szTip := 'fdel';
    sl.Free;

    hIcon := Application.Icon.Handle;
    uCallbackMessage := WM_MY_TRAYICON;
  end;
  Shell_NotifyIcon(NIM_MODIFY, @NotifyData);
end;

procedure TForm1.DeleteTaskBarIcon;
// ==========================================================================//
// アイコンを削除する
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
begin
  with NotifyData do
  begin
    // cbSize := SizeOf(TNotifyIconData);
    cbSize := 100;
    Wnd := hWndTrayIcon;
    uID := 0;
  end;
  Shell_NotifyIcon(NIM_DELETE, @NotifyData);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit5Change(Sender: TObject);
// ==========================================================================//
// ファイル数制限　変更イベント
// ==========================================================================//
begin
  UpdateSignSet;
  try
    if StrToInt(Edit5.Text) > 10000 then
      Edit5.Text := '100';
  except
    Edit5.Text := '100';
  end;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit7Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.N1Click(Sender: TObject);
// ==========================================================================//
// popup menuクリックイベント
// popup menu 設定画面表示
// ==========================================================================//
begin
  Visible := true;
  ShowWindow(Application.Handle, SW_SHOW);
  VarToSetutei;
end;

procedure TForm1.N2Click(Sender: TObject);
// ==========================================================================//
// popup menuクリックイベント
// 監視一時停止の設定
// ==========================================================================//
begin
  if N2.Checked = true then
  begin
    N2.Checked := false;
    stop := false;
    CheckBox1.Checked := false;
  end
  else
  begin
    N2.Checked := true;
    stop := true;
    CheckBox1.Checked := true;
  end;
end;

procedure TForm1.N3Click(Sender: TObject);
// ==========================================================================//
// log表示クリックイベント
// fdel.logファイルをメモ帳で開く
// ==========================================================================//
var
  cmd: PAnsiChar;str:string;
begin
  str := 'Notepad.exe ' + FD.LogFileName;
  GetMem(cmd, length(str)+ 1);
  StrPCopy(cmd, str);
  WinExec(cmd, SW_SHOW);
end;

procedure TForm1.N4Click(Sender: TObject);
// ==========================================================================//
// popup menuクリックイベント
// help 表示
// ==========================================================================//
begin
  Form2.ShowModal;
end;

procedure TForm1.N5Click(Sender: TObject);
// ==========================================================================//
// popup menuクリックイベント
// popup menu 終了
// ==========================================================================//
begin
  close;
end;

procedure TForm1.TaskTrayWndProc(var Msg: TMessage);
// ==========================================================================//
// タスクトレイに来るメッセージを受信する
// ==========================================================================//
var
  ps: TPoint;
begin
  Case Msg.lParam of
    WM_LBUTTONDBLCLK:
      // 左ダブルクリック　設定画面表示
      begin
        Visible := true;
        ShowWindow(Application.Handle, SW_SHOW);
        VarToSetutei;
      end;
    WM_LBUTTONUP:
      // 左クリック　popup menu 表示
      begin
        GetCursorPos(ps);
        SetForegroundWindow(Handle);
        PopupMenu1.Popup(ps.x, ps.y);
        PostMessage(Handle, WM_NULL, 0, 0);
      end;
    WM_RBUTTONUP:
      // 右クリック　popup menu 表示
      begin
        GetCursorPos(ps);
        SetForegroundWindow(Handle);
        PopupMenu1.Popup(ps.x, ps.y);
        PostMessage(Handle, WM_NULL, 0, 0);
      end;
  else
    // タスクバーが移動・再構築された場合に消えたアイコンを再生成
    if (Msg.lParam = Longint(uTaskBarRecreate)) then
      CreateTaskBarIcon;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
// ==========================================================================//
// タイマイベント１　１秒間隔
// ==========================================================================//
begin
  StatusBar1.Panels[1].Text := '現在　' + FormatDateTime('mm/dd hh:nn:ss', Now);

  // 実行中
  if (stopBefore = false) and (stop = false) then
  begin
    Label9.Caption := '';
  end;

  // 実行中→停止中に変化
  if (stopBefore = false) and (stop = true) then
  begin
    Label9.Caption := '停止中';
    Timer2.Enabled := false;
    stopTime := Now;
    NextRunTime := Now + (1 / 1440 * Interval);
  end;

  // 停止中
  if (stopBefore = true) and (stop = true) then
  begin
    Label9.Caption := '停止中';
    StatusBar1.Panels[0].Text := '次回　' + FormatDateTime('mm/dd hh:nn:ss',
      NextRunTime + (Now - stopTime));
    Timer2.Enabled := false;
  end;

  // 停止中→実行中に変化
  if (stopBefore = true) and (stop = false) then
  begin
    NextRunTime := NextRunTime + (Now - stopTime);
    StatusBar1.Panels[0].Text := '次回　' + FormatDateTime('mm/dd hh:nn:ss',
      NextRunTime);
    Label9.Caption := '';
    Timer2.Enabled := true;
  end;

  // ＳＴＯＰ状態の保管
  stopBefore := stop;

  // タスクトレイの再表示
  // UpdateTaskBarIcon;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
// ==========================================================================//
// タイマイベント２
// ==========================================================================//
begin
  Timer2Pro;
end;

procedure TForm1.Timer2Pro;
// ==========================================================================//
// タイマイベント２
// ==========================================================================//
var
  // TargetFolderBackup:string;
  sl: TStringList;
  i: Integer;

begin
  StatusBar1.Panels[0].Text := '次回　' + FormatDateTime('mm/dd hh:nn:ss',
    Now + (1 / 1440 * Interval));
  NextRunTime := Now + (1 / 1440 * Interval);

  // TargetFolderBackup:=TargetFolder; //変数バックアップ

  sl := TStringList.create;
  sl.Delimiter := ';';
  sl.DelimitedText := AnsiReplaceText(FD.TargetFolder, ' ', '*');

  for i := 0 to sl.Count - 1 do
  begin
    // フォルダ名をターゲットフォルダ変数にセット
    FD.TargetFolderItem := AnsiReplaceText(sl.Strings[i], '*', ' ');
    if FD.TargetFolderItem <> '' then
    begin
      FD.fileSearch;
      FD.deleteAnalysis;
      FD.Delete;
    end;
  end;

  sl.Free;
  // TargetFolder:=TargetFolderBackup;  //変数の戻し

end;

procedure TForm1.iniFileRead;
// ==========================================================================//
// ini file 読み込み
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    stop := Ini.ReadBool('Folder', 'stop', true);
    Interval := Ini.ReadInteger('Folder', 'Interval', 60);
    fd.iniFileRead;
  finally
    Ini.Free
  end;
end;

procedure TForm1.iniFileWrite;
// ==========================================================================//
// ini file 書き込み
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    Ini.WriteBool('Folder', 'stop', stop);
    Ini.WriteInteger('Folder', 'Interval', Interval);
    fd.iniFileWrite;
  finally
    Ini.Free
  end;
end;

procedure TForm1.UpdateSignSet;
// ==========================================================================//
// 設定変更サインセット
// ==========================================================================//
begin
  if UpdateSign = true then
    UpdateInfo := true;
end;

function BrowseCallbackProc(hWnd: hWnd; uMsg: UINT;
  lParam, lpData: lParam): Integer;
// ==========================================================================//
// フォルダ検索ダイアログ表示 コールバック関数
// ==========================================================================//
var
  Path: array [0 .. 65536] of Char;
begin
  // BIF_STATUSTEXT以外は何もしない。
  if BI.ulFlags = BIF_STATUSTEXT then
  begin
    // ユーザーがフォルダを変更した時
    if uMsg = BFFM_SELCHANGED then
    begin
      // ITEMIDLIST構造体からパス名を取り出す
      SHGetPathFromIDList(PItemIDList(lParam), Path);
      // 変更されたフォルダのパスを表示する
      SendMessage(hWnd, BFFM_SETSTATUSTEXT, 0, Longint(String(Path)));
    end;
  end;
  Result := 0;
end;

function FileTimeToDateTime(FileTime: TFileTime): TDateTime;
// =============================================================================
// TFileTime型の値をDelphiのTDateTime型に変換する関数
// =============================================================================
var
  LocalFileTime: TFileTime;
  SystemTime: TSystemTime;
begin
  Result := 0;
  if (FileTime.dwLowDateTime = 0) and (FileTime.dwHighDateTime = 0) then
    exit;
  FileTimeToLocalFileTime(FileTime, LocalFileTime); { ローカル日時に変換 }
  FileTimeToSystemTime(LocalFileTime, SystemTime); { システム日時に変換 }
  Result := SystemTimeToDateTime(SystemTime); { TDateTime型に変換 }
end;

// ==========================================================================//
// ２重起動防止処理
// ==========================================================================//
var
  MutexName: string;
  hMutex: THandle;
  sl: TStringList;
  i: Integer;

initialization

MutexName := AnsiReplaceText(Application.ExeName, '\', ''); // 任意の文字列
hMutex := OpenMutex(MUTEX_ALL_ACCESS, false, PChar(MutexName));
if hMutex <> 0 then
begin
  CloseHandle(hMutex);
  Halt;
end;
hMutex := CreateMutex(nil, false, PChar(MutexName));

finalization

ReleaseMutex(hMutex);

end.
