unit startup;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ShlObj, Vcl.StdCtrls, ActiveX, ComObj;

type
  TForm4 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var Form4: TForm4;

implementation

{$R *.dfm}

function GetStartupFolder: string;
var Path: array [0 .. MAX_PATH] of Char; pidl: PItemIDList;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_STARTUP, pidl);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
end;

function GetFolderName: string;
begin
  Result := ExtractFilePath(ParamStr(0));
end;

function GetExeName: string;
begin
  Result := StringReplace(ParamStr(0), ExtractFilePath(ParamStr(0)), '', [rfReplaceAll]);
end;

function CreateShortCut(ShortcutPath, ExecFilePath, SavePath: string): boolean;
var SL: IShelllink; PF: IPersistFile; wFileName: WideString;
begin
  Result := false;
  SL := CreateComObject(CLSID_ShellLink) as IShelllink;
  PF := SL as IPersistFile;
  if SL.SetPath(PChar(ExecFilePath)) <> NOERROR then Abort;
  if SL.SetWorkingDirectory(PChar(ExtractFilePath(ExecFilePath))) <> NOERROR then Abort;
  wFileName := SavePath + '\' + ChangeFileExt(ExtractFileName(ShortcutPath), '') + '.lnk';
  if PF.Save(PWChar(wFileName), false) <> NOERROR then Abort;
  Result := true;
end;

procedure TForm4.Button1Click(Sender: TObject);
var ShortcutPath: string;
begin
  ShortcutPath := Edit1.Text;
  if ShortcutPath = '' then ShortcutPath := GetExeName;
  if CreateShortCut(ShortcutPath, GetFolderName + GetExeName, GetStartupFolder) then begin
    showmessage('o^');
    Form4.Close;
  end
  else showmessage('o^s');

end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  Form4.Close;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'fdel';
end;

end.
